searchNodes=[{"doc":"","ref":"Cognac.html","title":"Cognac","type":"module"},{"doc":"Convert keyword list/tuple list to GraphQL mutation query string iex&gt; mutation = [ hero : [ :name , friends : [ :name ] ] ] iex&gt; Cognac . mutation ( mutation ) |&gt; IO . puts mutation { updateHero ( name :&quot;Steve&quot; ) { name } } Options :output :iodata (default) - Outputs as IO data :binary - Outputs query as a binary string pretty false (default) - Outputs minimal query true - Outputs prettified query with indentation and linebreaks","ref":"Cognac.html#mutation/2","title":"Cognac.mutation/2","type":"function"},{"doc":"Convert keyword list/tuple list to GraphQL query string iex&gt; query = [ hero : [ :name , friends : [ :name ] ] ] iex&gt; Cognac . query ( query ) |&gt; IO . puts query { hero { name friends { name } } } Options :output :iodata (default) - Outputs as IO data :binary - Outputs query as a binary string pretty false (default) - Outputs minimal query true - Outputs prettified query with indentation and linebreaks","ref":"Cognac.html#query/2","title":"Cognac.query/2","type":"function"},{"doc":"Convert keyword list/tuple list to GraphQL subscription query string iex&gt; subscription = [ heroUpdated : [ :name ] ] iex&gt; Cognac . subscription ( subscription ) |&gt; IO . puts subscription { heroUpdated { name } } Options :output :iodata (default) - Outputs as IO data :binary - Outputs query as a binary string pretty false (default) - Outputs minimal query true - Outputs prettified query with indentation and linebreaks","ref":"Cognac.html#subscription/2","title":"Cognac.subscription/2","type":"function"},{"doc":"Build GraphQL queries efficiently without string mashing. Pairs well with Absinthe .","ref":"readme.html","title":"Cognac","type":"extras"},{"doc":"Add Cognac as a dependency in your mix.exs file: def deps do [ { :cognac , &quot;~&gt; 0.2.0&quot; } ] end Then, run mix deps.get in your shell to fetch and compile Cognac. Start an interactive Elixir shell with iex -S mix . iex&gt; alias Cognac , as : C iex&gt; query = [ hero : [ :name , friends : [ :name ] ] ] iex&gt; C . query ( query ) |&gt; IO . puts query { hero { name friends { name } } } Examples In the current version, only simple queries, mutations and subscriptions are possible. Operation names and variables will be added in a future release.","ref":"readme.html#usage","title":"Cognac - Usage","type":"extras"},{"doc":"iex&gt; query = [ hero : [ :name , friends : [ :name ] ] ] iex&gt; Cognac . query ( query ) |&gt; IO . puts query { hero { name friends { name } } } Fields can also be specified using strings, albeit not as readably. iex&gt; query = [ { &quot;hero&quot; , [ &quot;name&quot; , { &quot;friends&quot; , [ &quot;name&quot; ] } ] } ] iex&gt; Cognac . query ( query ) |&gt; IO . puts query { hero { name friends { name } } }","ref":"readme.html#basic-query","title":"Cognac - Basic query","type":"extras"},{"doc":"Parameters are specified by assigning a tuple to a key, where the first element is a keyword list of parameters, and the second element is a list of subfields. iex&gt; query = [ heroes : { [ name : &quot;Steve&quot; , paginate : nil ] , [ :name , friends : [ :name ] ] } ] iex&gt; Cognac . query ( query ) |&gt; IO . puts query { heroes ( name :&quot;Steve&quot; , paginate :null ) { name friends { name } } } Which can be achieved at any level iex&gt; query = [ heroes : { [ name : &quot;Steve&quot; , paginate : nil ] , [ :name , friends : { [ class : :WARRIOR ] , [ :name ] } ] } ] iex&gt; Cognac . query ( query ) |&gt; IO . puts query { heroes ( name :&quot;Steve&quot; , paginate :null ) { name friends ( class :WARRIOR ) { name } } } Note that atom values are handled processed as unescaped strings, which can be useful for enumerable type values Options Use the :output option to either get the result as :iodata (default) or a :binary string. iex&gt; query = [ hero : [ :name , friends : [ :name ] ] ] iex&gt; Cognac . query ( query , output : :iodata ) [ &quot;query&quot; , [ 123 , [ &quot;hero&quot; , 123 , [ &quot;name&quot; , &quot; &quot; , &quot;friends&quot; , 123 , [ &quot;name&quot; ] , 125 ] , 125 ] , 125 ] ] iex&gt; Cognac . query ( query , output : :binary ) &quot;query{hero{name friends{name}}}&quot; Use the :pretty option (defaults to false ) to introduce indentation and line breaks which could possibly help with debugging. iex&gt; query = [ hero : [ :name , friends : [ :name ] ] ] iex&gt; Cognac . query ( query , pretty : true ) |&gt; IO . puts query { hero { name friends { name } } }","ref":"readme.html#query-with-parameters","title":"Cognac - Query with parameters","type":"extras"}]